// DO NOT EDIT
//   Generated from javascripts/dashboard/offline.coffee
//
(function() {
  var OfflinePage, OfflineSupport;
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; }, __slice = Array.prototype.slice;
  OfflineSupport = (function() {
    function OfflineSupport(platform, offlinePath) {
      this.platform = platform;
      this.offlinePath = offlinePath != null ? offlinePath : 'dashboard/offline';
      this._goOfflineMode = __bind(this._goOfflineMode, this);;
      this.inOfflinePage = __bind(this.inOfflinePage, this);;
      OF.debug("new OfflineSupport");
      this.handleOffline();
    }
    OfflineSupport.prototype.setOfflinePath = function(offlinePath) {
      this.offlinePath = offlinePath;
    };
    OfflineSupport.prototype.handleOffline = function() {
      var self;
      self = this;
      if (OF.action.isSupported('registerReachabilityCallbacks')) {
        OF.action('registerReachabilityCallbacks', {
          offline_callback: function() {
            return self._goOfflineMode('registerReachabilityCallbacks');
          },
          online_callback: function() {
            var _ref;
            return (_ref = OF.page.offlinePage) != null ? _ref.retryListener() : void 0;
          }
        });
      }
      return OF.api.handleDisconnect = __bind(function() {
        return this._goOfflineMode("handleDisconnect with path=" + self.offlinePath);
      }, this);
    };
    OfflineSupport.inPage = function() {
      var path, paths, _i, _len, _ref, _ref2, _ref3;
      paths = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      if ((_ref = OF.page) != null ? _ref.inPath : void 0) {
        return OF.page.inPath(paths);
      } else {
        for (_i = 0, _len = paths.length; _i < _len; _i++) {
          path = paths[_i];
          if (((_ref2 = OF.page) != null ? (_ref3 = _ref2.url) != null ? _ref3.indexOf(path) : void 0 : void 0) === 0) {
            return true;
          }
        }
        return false;
      }
    };
    OfflineSupport.prototype.inOfflinePage = function() {
      return this.constructor.inPage(this.offlinePath);
    };
    OfflineSupport.prototype._goOfflineMode = function(from) {
      OF.debug("goOfflineMode from " + from);
      if (!this.inOfflinePage()) {
        if (!this.goingOfflineMode) {
          this.goingOfflineMode = true;
          OF.offline = {
            page: OF.page
          };
          return setTimeout(__bind(function() {
            OF.push(this.offlinePath);
            return this.goingOfflineMode = false;
          }, this), 4000);
        }
      }
    };
    return OfflineSupport;
  })();
  OfflinePage = (function() {
    function OfflinePage(platform, params, options) {
      this.platform = platform;
      this.params = params != null ? params : {};
      this.options = options != null ? options : {};
      this.retryListener = __bind(this.retryListener, this);;
      OF.debug("new OfflinePage");
      setTimeout(__bind(function() {
        if (this.options.resize && OF.action.isSupported('resize')) {
          return OF.action('resize', {
            width: 290,
            height: 280
          });
        }
      }, this), 300);
      OF.api.offline = true;
      this.setVariantSignature();
      OF.page.scrolling = false;
      this.offlineBackMonkeyPatch();
      $('.retry').touch(this.retryListener);
      this.hideTabs();
      this.addContainerSignature();
      U.defer(__bind(function() {
        this.hideHeader();
        this.setViewportDimensions();
        if (this.platform === 'ios') {
          return $.removeCss('dashboard/user');
        }
      }, this));
    }
    OfflinePage.prototype.setVariantSignature = function() {
      if ('variant' in this.params) {
        return $(document.body).attr('id', this.params.variant);
      }
    };
    OfflinePage.prototype.retryListener = function() {
      OF.debug("OfflinePage.retryListener");
      OF.api.offline = false;
      if (OF.action.isSupported('reload')) {
        return OF.action('reload');
      } else {
        this.showTabs();
        return OF.goBack({
          root: true,
          callback: function() {
            return setTimeout(function() {
              return OF.refresh();
            }, 500);
          }
        });
      }
    };
    OfflinePage.prototype.setViewportDimensions = function(beforeOritationChanged) {
      var $body, height, orientationEvent, supportsOrientationChange, viewport, width, _ref, _ref2;
      if (beforeOritationChanged == null) {
        beforeOritationChanged = false;
      }
      OF.debug('setViewportDimensions');
      viewport = jQuery(window);
      _ref = ["" + (viewport.width()) + "px", "" + (viewport.height() + 20) + "px"], width = _ref[0], height = _ref[1];
      if (beforeOritationChanged) {
        _ref2 = [height, width], width = _ref2[0], height = _ref2[1];
      }
      $('#offline').css({
        height: height
      });
      $body = jQuery('body');
      if (!$body.data('hasMonkeyPatchOfSettingViewportDimensions')) {
        supportsOrientationChange = "onorientationchange" in window;
        orientationEvent = supportsOrientationChange ? "orientationchange" : "resize";
        window.addEventListener(orientationEvent, __bind(function() {
          if (OF.page.inPath('dashboard/offline')) {
            return this.setViewportDimensions(true);
          }
        }, this), false);
        return $body.data('hasMonkeyPatchOfSettingViewportDimensions', 'yes');
      }
    };
    OfflinePage.prototype.hideTabs = function() {
      if (OF.tabController) {
        return OF.tabController.hideNativeTabs();
      } else if (OF.platform === 'ios') {
        return OF.action('configureNativeTabs', {
          tabs: []
        });
      }
    };
    OfflinePage.prototype.showTabs = function() {
      if (OF.tabController) {
        return OF.tabController.showNativeTabs();
      }
    };
    OfflinePage.prototype.hideHeader = function() {
      OF.debug("hideHeader");
      return $('#header').hide();
    };
    OfflinePage.prototype.addContainerSignature = function() {
      return $('#intro .content').attr('id', 'content-offline');
    };
    OfflinePage.prototype.offlineBackMonkeyPatch = function() {
      var offlinePage, originalGoBack;
      if (this.platform === 'android') {
        originalGoBack = OF.goBack;
        if (!OF.goBack.offlineMonkeyPatched) {
          OF.goBack = function(options) {
            var _ref;
            if (options == null) {
              options = {};
            }
            if (((_ref = OF.offlineSupport) != null ? _ref.inOfflinePage() : void 0) && !options.root) {
              return OF.action('dismiss');
            } else {
              return originalGoBack(options);
            }
          };
          OF.goBack.offlineMonkeyPatched = true;
        }
      }
      if (this.platform === 'ios') {
        if (!OF.goBack.offlineMonkeyPatched) {
          originalGoBack = OF.goBack;
          offlinePage = OF.page;
          OF.goBack = __bind(function(options) {
            if (options == null) {
              options = {};
            }
            if (OF.page === offlinePage) {
              return this.retryListener();
            } else {
              OF.goBack = originalGoBack;
              return OF.goBack();
            }
          }, this);
          return OF.goBack.offlineMonkeyPatched = true;
        }
      }
    };
    return OfflinePage;
  })();
  if (!('manager' in OfflineSupport)) {
    OfflineSupport.manager = {
      instance: null,
      useOfflinePath: function(offlinePath) {
        if (OfflineSupport.manager.instance == null) {
          return OfflineSupport.manager.instance = new OfflineSupport(OF.platform, offlinePath);
        } else {
          return OfflineSupport.manager.instance.setOfflinePath(offlinePath);
        }
      }
    };
  }
  OfflineSupport.OfflinePage = OfflinePage;
  this.OfflineSupport = OfflineSupport;
}).call(this);
